
namespace Core.GameObjects.States
{
    /// <summary>
    /// This is the base state class, when creating any state this class will be inherited.
    /// Supprise eh....
    /// </summary>
    public abstract class BasicState
    {
        public BasicState()
        { }

        /// <summary>
        /// Called when the state is entered.
        /// </summary>
        /// <param name="agent">Agent that this state is asociated with</param>
        public virtual void Enter(GameObject gObject)
        { }
        /// <summary>
        /// Called when the state is executed. 
        /// This is where all your AI logic will be called from.
        /// 
        /// It is important that your interface has the methods you need to access the associated agents
        /// world object members as you will want to use these fields/properties and/or methods to help
        /// weight the desisions your AI will take.
        /// </summary>
        /// <param name="agent">Agent that this state is asociated with</param>
        public virtual void Execute(GameObject gObject)
        { }
        /// <summary>
        /// Called when the state is exited.
        /// </summary>
        /// <param name="agent">Agent that this state is asociated with</param>
        public virtual void Exit(GameObject gObject)
        { }
    }
}
