﻿using System;
using System.Xml.Serialization;
using Microsoft.Xna.Framework;
using Core.Graphics.Layers;

namespace Core.Graphics
{
    [Serializable()]
    public class Image
    {
        /// <summary>Image Identifier Name</summary>
        [XmlAttribute("Name")]
        public string Name { get; set; }

        /// <summary>Image Layers</summary>
        [XmlArray("Layers")]
        public LayerCollection Layers { get; set; }

        /// <summary>Width in Pixels</summary>
        [XmlAttribute("Width")]
        public int Width { get; set; }

        /// <summary>Height in Pixels</summary>
        [XmlAttribute("Height")]
        public int Height { get; set; }
    }
}
