using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Core.Graphics;

namespace WorldEditor.Tiles
{
    public partial class CharacterAllViews : UserControl
    {
        public TileSet TileSet
        {
            get { return _TileSet; }
            set { _TileSet = value; }
        }

        protected TileSet _TileSet;

        public CharacterAllViews(TileSet ts)
        {
            _TileSet = ts;

            InitializeComponent();

            ctvDown.SetTileSet(ts);
            ctvLeft.SetTileSet(ts);
            ctvRight.SetTileSet(ts);
            ctvUp.SetTileSet(ts);
        }

        public bool AnimationEnabled
        {
            get { return ctvDown.AnimationEnabled; }
            set
            {
                ctvDown.AnimationEnabled = value;
                ctvLeft.AnimationEnabled = value;
                ctvRight.AnimationEnabled = value;
                ctvUp.AnimationEnabled = value;
            }
        }
    }
}
